#include <cstdio>
#include <map>
#include <string>
#include <vector>

using namespace std;

struct Wart
{
	long long a;
	int jedn;
	Wart(long long za, int w) : a(za), jedn(w) {}
};

double tab[5][5];	/* tab[i][j] = a <==> jedn[i] = a * jedn[j] */

double odl(Wart a, Wart b)
{
	return a.a * tab[a.jedn][b.jedn] - b.a;
}

bool cd(Wart a, Wart b)
{
	if (a.a * tab[a.jedn][b.jedn] <= b.a)
		return true;
	return false;
}

vector<Wart> wz;

int znajdz(int l, int r, Wart a)
{
	if (l >= r-1)
		return l;
	if (cd(a, wz[(l + r) >> 1]))
		return znajdz(l, (l+r)>>1, a);
	else
		return znajdz((l+r)>>1, r, a);
}

void rob()
{
	char s1[111], s2[111];
	char bles[15];
	
	map<string, long long> jedn;
	string *nazwa = new string[5];
	string najm;
	int k, ileprzel, i, j, ilejedn, ble, ileq, strzal;
	long long wsp;
	scanf("%d", &ileprzel);
	ilejedn = 0;
	
	wz.clear();

	for (i = 0; i < 5; ++i)
		for (j = 0; j < 5; ++j)
			if (i == j)
				tab[i][j] = 1;
			else
				tab[i][j] = 0;
	
	for (i = 0; i < ileprzel; ++i)
	{
		scanf("%d %s %s %Ld %s", &ble, s1, bles, &wsp, s2);
		if (jedn[s1] == 0)
		{
			jedn[s1] = ++ilejedn;
			nazwa[ilejedn] = s1;
		}
		if (jedn[s2] == 0)
		{
			jedn[s2] = ++ilejedn;
			nazwa[ilejedn] = s2;
		}
		tab[jedn[s1]][jedn[s2]] = wsp;
		tab[jedn[s2]][jedn[s1]] = 1 / (double) wsp;
	}
	for (k = 1; k <= ilejedn; ++k)
		for (i = 1; i <= ilejedn; ++i)
			if (tab[i][k])
				for (j = 1; j <= ilejedn; ++j)
					if (tab[k][j] && tab[i][j] == 0)
						tab[i][j] = tab[i][k] * tab[k][j];
	int w;
	scanf("%d", &w);
	for (i = 0; i < w; ++i)
	{
		scanf("%Ld %s", &wsp, s1);
		wz.push_back(Wart(wsp, jedn[s1]));
	}

	sort (wz.begin(), wz.end(), cd);


	scanf("%d", &ileq);
	for (i = 0; i < ileq; ++i)
	{
		scanf("%Ld %s", &wsp, s1);
		Wart r(wsp, jedn[s1]);
		strzal = znajdz(0, w, r);
		if (strzal + 1 < w)
		{
			if (odl(wz[strzal+1], r) < odl(wz[strzal], r))
				strzal++;
		}
		printf("%d %s\n", wz[strzal].a, nazwa[wz[strzal].jedn].c_str());
	}
	delete [] nazwa;
}

int main()
{
	int i,d=0;
	scanf("%d", &d);
	for (i = 0; i < d; ++i)
		rob();
	return 0;
}
