#include <cstdio>

using namespace std;

struct Punkt
{
	long long x, y;
};

void zamien(struct Punkt* t, int a, int b)
{
	long long z = t[a].x; t[a].x = t[b].x; t[b].x = z;
	z = t[a].y; t[a].y = t[b].y; t[b].y = z;
}

long long blabs(long long a)
{
	if (a < 0)
		return -a;
	return a;
}

bool cmp(struct Punkt a, struct Punkt b)
{
	if (a.x * b.y > a.y * b.x)
		return true;
	if (a.x * b.y == a.y * b.x)
		return (blabs(a.x) + blabs(a.y)) > (blabs(b.x) + blabs(b.y));
	return false;
}


void sort(struct Punkt *a, int l, int r)
{
	int i, j;
	struct Punkt x;
	i = l; j= r; x= a[(l+r) >> 1];
	while (i <= j)
	{
		while (cmp(a[i], x))
			++i;
		while (cmp(x, a[j]))
			--j;
		/*while (a[i].x * x.y > a[i].y * x.x)
			++i;
		while (a[j].x * x.y < a[j].y * x.x)
			--j;*/
		if (i < j)
		{
			zamien(a, i, j);
			++i; --j;
		}
		else if (i == j)
		{
			++i; --j;
		}
	}
	if (l < j) sort(a, l, j);
	if (i < r) sort(a, i, r);
}

long long odl2(struct Punkt a, struct Punkt b)
{
	return (a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y);
}

void rob()
{
	int n, i;
	long long a, b;
	struct Punkt *t = new struct Punkt[n+1];
	scanf("%d", &n);
	long long prevx = -1000000001;
	int ile = 0;
	int j = 0;
	int pocz = 0;
int min=0;
	for (i = 0; i < n; ++i)
	{
		scanf("%Ld%Ld", &a, &b);
		/*if (a != prevx)
		{
			ile = 1;
			j++;
		}
		else if (ile == 1)
		{
			ile = 2;
			j++;
		}*/
		t[j].x = a; prevx = t[j].y = b;
	if(t[j].y < t[min].y) 
		if(t[j].x < t[min].x)
			min=j;
		++j;
	}
zamien(t,j,min);
	n = j;
	if ( n == 2)
	{
		printf("%Ld\n", odl2(t[0], t[1]));
		return;
	}
	for (i = 1; i < n; ++i)
	{
		t[i].x -= t[0].x;
		t[i].y -= t[0].y;
	}
	t[0].x = t[0].y = 0;

	sort(t, 1, n-1);

	pocz = 1;
	
	long long kart;
	int *stos = new int[n+1];
	stos[0] = 0;
	stos[1] = 1;
	stos[2] = 2;

	ile = 3;
	for (i = stos[2]+1; i < n; ++i)	/* tu jest BUG */
	{
		kart = (t[i].x - t[stos[ile-2]].x) *
			(t[stos[ile-1]].y - t[stos[ile-2]].y) -
			(t[stos[ile-1]].x - t[stos[ile-2]].x) *
			(t[i].y - t[stos[ile-2]].y);
		while ((kart > 0) || (kart == 0 && 
					(odl2(t[stos[ile-1]], t[stos[ile-2]]) < odl2(t[i],t[stos[ile-2]]))))
		{
			--ile;
			kart = (t[i].x - t[stos[ile-2]].x) *
				(t[stos[ile-1]].y - t[stos[ile-2]].y) -
				(t[stos[ile-1]].x - t[stos[ile-2]].x) *
				(t[i].y - t[stos[ile-2]].y);
		}
		stos[ile++] = i;
	}

	long long maks = 0;
	
	i = 0; j = 1;
	while (j < ile)
	{
		while (j+1 < ile && odl2( t[stos[i]], t[stos[j+1]]) > odl2( t[stos[i]], t[stos[j]]))
			++j;
		maks >?= odl2(t[stos[i]], t[stos[j]]);
		++i; 
		if (i >= j)
			j = i+1;
	}
	printf("%Ld\n", maks);
	delete [] t;
	delete [] stos;
}


int main()
{
	int i,d=0;
	scanf("%d", &d);
	for (i = 0; i < d; ++i)
		rob();
	return 0;
}
